/*
 * Mach Operating System
 * Copyright (c) 1992 Carnegie Mellon University
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */

#ifndef _amiga_a3000_h
#define _amiga_a3000_h

#define PHYS_A3000_DMAC 0xdd0000

struct a3000_dmac_t {
  u_short _____________pad0;
  u_short DACK_width;
  u_short _____________pad1[3];
  u_short control;
  void    *DMA_address;
  u_short _____________pad2;
  u_short start_DMA;			/* strobe */
  u_short _____________pad3;
  u_short flush_DMA;			/* strobe */
  u_short _____________pad4;
  u_short clear_ints;			/* strobe */
  u_short _____________pad5;
  u_short int_status;
  u_short _____________pad6[15];
  u_short stop_DMA;			/* strobe */
  u_char  _____________pad7;
  u_char  wd_address;
  u_char  _____________pad8;
  u_char  wd_data;
};

/* bits in `int_status' */
#define A3000_DMAC_DMA_IDLE	(1<<0)
#define A3000_DMAC_INT_PENDING	(1<<4)

/* settings in `control' */
#define A3000_DMAC_DIR_READ	((1<<2) | (1<<3))
#define A3000_DMAC_DIR_WRITE	((1<<1) | (1<<2) | (1<<3))

/* used value for `DACK_width' */
#define A3000_DMAC_WIDTH	3


#ifdef KERNEL
#define a3000_dmac (*((volatile struct a3000_dmac_t *)VM_A3000_DMAC))
#define phys_a3000_dmac (*((volatile struct a3000_dmac_t *)PHYS_A3000_DMAC))
#define A3000_SCSI_ADDR (&a3000_dmac._____________pad7)
#define PHYS_A3000_SCSI_ADDR (&phys_a3000_dmac._____________pad7)
#endif


#endif /* _amiga_a3000_h */
